require 'json'
require 'ghtorrent'


class GHTQueueGrep < GHTorrent::Command

  include GHTorrent::Persister

  def persister
    @persister ||= connect(:mongo, settings)
    @persister
  end

  def retrieve_event(evt_id)
    event = persister.get_underlying_connection[:events].find_one('id' => evt_id)
    event.delete '_id'
    data = JSON.parse(event.to_json)
    data
  end

  def go

    processor = Proc.new do |evt_id|
      e = retrieve_event(evt_id)

      comment = case e['type']
                  when /CommitCommentEvent/
                    e['payload']['comment']['body']
                  when /PullRequestReviewCommentEvent/
                    e['payload']['body']
                  when /IssueCommentEvent/
                    e['payload']['comment']['body']
                end

      url = case e['type']
              when /CommitCommentEvent/
                e['payload']['comment']['html_url']
              when /PullRequestReviewCommentEvent/
                e['payload']['comment']['html_url']
              when /IssueCommentEvent/
                e['payload']['comment']['html_url']
            end

      if comment =~ %r[security|csrf|xss|injection]im
        puts "#{e['repo']['name']} #{url}"
      end

    end

    queue_client 'comments', processor
  end

end

GHTQueueGrep.run